/* The Convex IRC System is (C) 2003 by HardCore SoftWare

   Your right to use, copy, and modify this software are protected under
   the GNU General Public License, available at www.gnu.org
*/


#include <stdio.h>
#include <stdlib.h>

#include "convex.h"



int iswhitespace(char tp) {
  if (tp == ' ' || tp == '\n' || tp == '\t') return 1;
  return 0;
}



void add_to_map(struct map_struct *base, char *pattern, char *result, 
                              int type) {
  struct map_struct *tp;

  tp = (struct map_struct *) malloc(sizeof(struct map_struct));

  tp->pattern = (char *) malloc(strlen(pattern)+1);
  tp->result = (char *) malloc(strlen(result)+1);
  tp->type = type;
  strcpy(tp->pattern, pattern);
  strcpy(tp->result, result);

  while (base->next != NULL) base = base->next;

  base->next = tp;
  tp->next = NULL;

}



void procmap(struct map_struct *curr, FILE *fp, char *buf) {

  char tpp[1000];
  int i, type;
  char *tp;

  while(iswhitespace(*buf)) buf++;

  if (*buf == '#') return;
  else if ((*buf == 'M' || *buf == 'C')
             && buf[1] == ':' && buf[2] == '"') {

    if (*buf == 'M') type = 0;
    else type = 1;

    buf+=3;
    for(i=0; buf[i] != '"'; i++)  ;
    buf[i] = '\0';

    if (fgets(tpp, sizeof(tpp)-1, fp) == NULL) {
      fprintf(stderr, "Bad conf file\n");
      exit(0);
    }
    tp = tpp;

    while(iswhitespace(*tp)) tp++;

    if (*tp != '"') {
      fprintf(stderr, "Bad conf file\n");
      exit(0);
    }
    tp++;

    for(i=0; tp[i] != '"'; i++)  ;
    tp[i] = '\0';

    i=0;
    while(tp[i]) {
      if(tp[i] == '\\' && tp[i+1] == 'n') {
        tp[i] = '\n';
        strcpy(tp+i+1, tp+i+2);
      }
      i++;
    }

    add_to_map(curr, buf, tp, type);

  }

}



struct map_struct *build_map(char *fname) {
  FILE *fp;
  struct map_struct *base=NULL;
  char buf[1000];
  char tpfname[1000];

  if (fname[0] == '-') {
    fp = stdin;
  } else {
    snprintf(tpfname, sizeof(tpfname), "m4 %s", fname);
    fp = popen(tpfname, "r");
    if (fp == NULL) {
      fprintf(stderr, "There was some problem m4ing your conf file.\n");
      exit(0);
    }
  }

  base = (struct map_struct *) malloc(sizeof(struct map_struct));
  base->next = NULL;
  base->type = -1;
  base->pattern = NULL;
  base->result = NULL;

  while(fgets(buf, sizeof(buf)-1, fp) != NULL) procmap(base, fp, buf);

  if (fname[0] == '-') pclose(fp);
  else fclose(fp);

  return base;

}
