/* The Convex IRC System is (C) 2003 by HardCore SoftWare

   Your right to use, copy, and modify this software are protected under
   the GNU General Public License, available at www.gnu.org
*/


struct map_struct {
  int type; /* 0=map  1=constant */
  char *pattern;
  char *result;

  struct map_struct *next;
};

struct bind_struct {
  char *name;
  int namelen;
  char *text;
  int textlen;

  struct bind_struct *next;
};

extern char *conffile;


/* Create a map from a filename (build.c) */
struct map_struct *build_map(char *fname);

/* Look for a match in a map (wildtest.c) */
int getmatch(char *in, char *out, int maxout, struct map_struct *map);

/* Look for a constant match in a map (consts.c) */
char *get_const(struct map_struct *map, char *cname);

/* Preform the actual IRC logic (socket.c) */
void do_irc(struct map_struct *map);

/* Destroy old map and create new one (rehash.c) */
struct map_struct *rehash(struct map_struct *map);

/* Things for handling death signals (die.c) */
void die_setsock(int sd);
void die_setqmsg(char *qm);
void die_normal();
void die_sneaky();
